import 'package:flutter_test/flutter_test.dart';

import 'placeholder_api.dart';
import 'post_dto.dart';

void main() {
  test('GET Object', _getObjectTest);
  test('GET List', _getListTest);
  test('POST Object', _postTest);
}

Future _getObjectTest() async {
  final api = PlaceholderApi();
  final singlePostResponse = await api.get(PlaceholderApi.postEndpoint, {'id': 1});
  singlePostResponse.throwOnError();
  print(singlePostResponse.data);
}

Future _getListTest() async {
  final api = PlaceholderApi();
  final postsResponse = await api.get(PlaceholderApi.postsEndpoint);
  postsResponse.throwOnError();
  print(postsResponse.data.length);
}

Future _postTest() async {
  final api = PlaceholderApi();
  final post = Post.create(title: 'moin', body: 'test');
  print('Sending:');
  print(post.toString());
  final postResponse = await api.post(PlaceholderApi.postsEndpoint, post);
  final responsePost = postResponse.data.first;
  print('Received:');
  print(responsePost.toString());
  expect(responsePost.title, equals(post.title));
  expect(responsePost.body, equals(post.body));
  expect(responsePost.userId, equals(post.userId));
}

