import 'package:cl_appbase/appbase.dart';

class Post extends TransferObject {
  static Post factory(data) => Post(data);

  static const idField = IntField('id');
  static const titleField = StrField('title');
  static const bodyField = StrField('body');
  static const userIdField = IntField('userId');

  static const fields = <Field>[
    idField,
    titleField,
    bodyField,
    userIdField
  ];

  Post(Map<String, dynamic> data) : super(fields, data);

  Post.create({int? id, String? title, String? body, int? userId})
    : super.fields({idField: id, titleField: title, bodyField: body, userIdField: userId});

  int? get id => get(idField);
  String? get title => get(titleField);
  String? get body => get(bodyField);
  int? get userId => get(userIdField);

  @override
  String toString() {
    return 'id: $id\ntitle: $title\nbody: $body\nuserId: $userId';
  }
}